<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>TypedEventEmitter</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/common/events/event-emitter.ts</code>
        </p>





            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#eventEmitter">eventEmitter</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#addListener">addListener</a>
                            </li>
                            <li>
                                <a href="#emit">emit</a>
                            </li>
                            <li>
                                <a href="#emitToId">emitToId</a>
                            </li>
                            <li>
                                <a href="#eventNames">eventNames</a>
                            </li>
                            <li>
                                <a href="#getMaxListeners">getMaxListeners</a>
                            </li>
                            <li>
                                <a href="#listenerCount">listenerCount</a>
                            </li>
                            <li>
                                <a href="#listeners">listeners</a>
                            </li>
                            <li>
                                <a href="#off">off</a>
                            </li>
                            <li>
                                <a href="#on">on</a>
                            </li>
                            <li>
                                <a href="#once">once</a>
                            </li>
                            <li>
                                <a href="#onId">onId</a>
                            </li>
                            <li>
                                <a href="#prependListener">prependListener</a>
                            </li>
                            <li>
                                <a href="#prependOnceListener">prependOnceListener</a>
                            </li>
                            <li>
                                <a href="#rawListeners">rawListeners</a>
                            </li>
                            <li>
                                <a href="#removeAllListeners">removeAllListeners</a>
                            </li>
                            <li>
                                <a href="#removeListener">removeListener</a>
                            </li>
                            <li>
                                <a href="#setMaxListeners">setMaxListeners</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>


            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="eventEmitter"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Readonly</span>
                            eventEmitter</b>
                            <a href="#eventEmitter"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>new EventEmitter</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="22" class="link-to-prism">src/common/events/event-emitter.ts:22</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="addListener"></a>
                    <span class="name">
                        <b>
                            addListener
                        </b>
                        <a href="#addListener"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>addListener(event: K, listener: (undefined,args: any[]) => void)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="24"
                            class="link-to-prism">src/common/events/event-emitter.ts:24</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>listener</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/function" target="_blank" >function</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="emit"></a>
                    <span class="name">
                        <b>
                            emit
                        </b>
                        <a href="#emit"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>emit(event: K, listener)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="72"
                            class="link-to-prism">src/common/events/event-emitter.ts:72</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>listener</td>
                                    <td>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/boolean" target="_blank" >boolean</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="emitToId"></a>
                    <span class="name">
                        <b>
                            emitToId
                        </b>
                        <a href="#emitToId"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>emitToId(event: K, id: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, listener)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="76"
                            class="link-to-prism">src/common/events/event-emitter.ts:76</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>id</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>listener</td>
                                    <td>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/boolean" target="_blank" >boolean</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="eventNames"></a>
                    <span class="name">
                        <b>
                            eventNames
                        </b>
                        <a href="#eventNames"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>eventNames()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="93"
                            class="link-to-prism">src/common/events/event-emitter.ts:93</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>    <code>[]</code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getMaxListeners"></a>
                    <span class="name">
                        <b>
                            getMaxListeners
                        </b>
                        <a href="#getMaxListeners"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>getMaxListeners()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="60"
                            class="link-to-prism">src/common/events/event-emitter.ts:60</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="listenerCount"></a>
                    <span class="name">
                        <b>
                            listenerCount
                        </b>
                        <a href="#listenerCount"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>listenerCount(type: K)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="81"
                            class="link-to-prism">src/common/events/event-emitter.ts:81</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>type</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="listeners"></a>
                    <span class="name">
                        <b>
                            listeners
                        </b>
                        <a href="#listeners"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>listeners(event: K)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="64"
                            class="link-to-prism">src/common/events/event-emitter.ts:64</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>Function[]</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="off"></a>
                    <span class="name">
                        <b>
                            off
                        </b>
                        <a href="#off"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>off(event: K, listener: (undefined,args: any[]) => void)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="46"
                            class="link-to-prism">src/common/events/event-emitter.ts:46</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>listener</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/function" target="_blank" >function</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="on"></a>
                    <span class="name">
                        <b>
                            on
                        </b>
                        <a href="#on"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>on(event: K, listener: (undefined,args: any[]) => void)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="29"
                            class="link-to-prism">src/common/events/event-emitter.ts:29</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>listener</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/function" target="_blank" >function</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="once"></a>
                    <span class="name">
                        <b>
                            once
                        </b>
                        <a href="#once"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>once(event: K, listener: (undefined,args: any[]) => void)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="38"
                            class="link-to-prism">src/common/events/event-emitter.ts:38</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>listener</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/function" target="_blank" >function</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="onId"></a>
                    <span class="name">
                        <b>
                            onId
                        </b>
                        <a href="#onId"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>onId(event: K, id: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>, listener: (undefined,args: any[]) => void)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="33"
                            class="link-to-prism">src/common/events/event-emitter.ts:33</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>id</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>listener</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/function" target="_blank" >function</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="prependListener"></a>
                    <span class="name">
                        <b>
                            prependListener
                        </b>
                        <a href="#prependListener"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>prependListener(event: K, listener: (undefined,args: any[]) => void)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="85"
                            class="link-to-prism">src/common/events/event-emitter.ts:85</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>listener</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/function" target="_blank" >function</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="prependOnceListener"></a>
                    <span class="name">
                        <b>
                            prependOnceListener
                        </b>
                        <a href="#prependOnceListener"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>prependOnceListener(event: K, listener: (undefined,args: any[]) => void)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="89"
                            class="link-to-prism">src/common/events/event-emitter.ts:89</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>listener</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/function" target="_blank" >function</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="rawListeners"></a>
                    <span class="name">
                        <b>
                            rawListeners
                        </b>
                        <a href="#rawListeners"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>rawListeners(event: K)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="68"
                            class="link-to-prism">src/common/events/event-emitter.ts:68</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>Function[]</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="removeAllListeners"></a>
                    <span class="name">
                        <b>
                            removeAllListeners
                        </b>
                        <a href="#removeAllListeners"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>removeAllListeners(event?: K)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="50"
                            class="link-to-prism">src/common/events/event-emitter.ts:50</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        Yes
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="removeListener"></a>
                    <span class="name">
                        <b>
                            removeListener
                        </b>
                        <a href="#removeListener"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>removeListener(event: K, listener: (undefined,args: any[]) => void)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="42"
                            class="link-to-prism">src/common/events/event-emitter.ts:42</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>event</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>listener</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/function" target="_blank" >function</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="setMaxListeners"></a>
                    <span class="name">
                        <b>
                            setMaxListeners
                        </b>
                        <a href="#setMaxListeners"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>setMaxListeners(n: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank">number</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="56"
                            class="link-to-prism">src/common/events/event-emitter.ts:56</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>n</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>





    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { EventEmitter } from &quot;events&quot;

// https://github.com/stemmlerjs/white-label
// https://khalilstemmler.com/articles/typescript-domain-driven-design/chain-business-logic-domain-events/

function Saga() {
    return function(target, propertyKey, descriptor: PropertyDescriptor) {

        let originalMethod &#x3D; descriptor.value
        console.log(&#x27;Saga&#x27;)
        console.log(descriptor)

        descriptor.value &#x3D; function (...args: any[]) {
            console.log(&#x27;Saga II&#x27;)
            console.log(args)
            return originalMethod.apply(this, args)
        }
    }
}

export class TypedEventEmitter&lt;T&gt; {
    private readonly eventEmitter &#x3D; new EventEmitter

    addListener&lt;K extends keyof T&gt;(event: K, listener: (payload: T[K], ...args: any[]) &#x3D;&gt; void): void {
        this.eventEmitter.addListener(&#x60;${event}&#x60;, listener)
    }

    // @Saga()
    on&lt;K extends keyof T&gt;(event: K, listener: (payload: T[K], ...args: any[]) &#x3D;&gt; void) {
        this.eventEmitter.on(&#x60;${event}&#x60;, listener)
    }

    onId&lt;K extends keyof T&gt;(event: K, id: string, listener: (payload: T[K], ...args: any[]) &#x3D;&gt; void) {
        const eventName &#x3D; &#x60;${event}_${id}&#x60;
        this.eventEmitter.on(eventName, listener)
    }

    once&lt;K extends keyof T&gt;(event: K, listener: (payload: T[K], ...args: any[]) &#x3D;&gt; void) {
        this.eventEmitter.once(&#x60;${event}&#x60;, listener)
    }

    removeListener&lt;K extends keyof T&gt;(event: K, listener: (payload: T[K], ...args: any[]) &#x3D;&gt; void) {
        this.eventEmitter.removeListener(&#x60;${event}&#x60;, listener)
    }

    off&lt;K extends keyof T&gt;(event: K, listener: (payload: T[K], ...args: any[]) &#x3D;&gt; void) {
        this.eventEmitter.off(&#x60;${event}&#x60;, listener)
    }

    removeAllListeners&lt;K extends keyof T&gt;(event?: K) {
        event !&#x3D;&#x3D; undefined ?
            this.eventEmitter.removeAllListeners(&#x60;${event}&#x60;) :
            this.eventEmitter.removeAllListeners()
    }

    setMaxListeners(n: number) {
        this.eventEmitter.setMaxListeners(n)
    }

    getMaxListeners(): number {
        return this.eventEmitter.getMaxListeners()
    }

    listeners&lt;K extends keyof T&gt;(event: K): Function[] {
        return this.eventEmitter.listeners(&#x60;${event}&#x60;)
    }

    rawListeners&lt;K extends keyof T&gt;(event: K): Function[] {
        return this.eventEmitter.rawListeners(&#x60;${event}&#x60;)
    }

    emit&lt;K extends keyof T&gt;(event: K, listener: T[K]): boolean {
        return this.eventEmitter.emit(&#x60;${event}&#x60;, listener)
    }

    emitToId&lt;K extends keyof T&gt;(event: K, id: string, listener: T[K]): boolean {
        const eventName &#x3D; &#x60;${event}_${id}&#x60;
        return this.eventEmitter.emit(eventName, listener)
    }

    listenerCount&lt;K extends keyof T&gt;(type: K): number {
        return this.eventEmitter.listenerCount(&#x60;${type}&#x60;)
    }

    prependListener&lt;K extends keyof T&gt;(event: K, listener: (arg0: T[K], ...args: any[]) &#x3D;&gt; void) {
        this.eventEmitter.prependListener(&#x60;${event}&#x60;, listener)
    }

    prependOnceListener&lt;K extends keyof T&gt;(event: K, listener: (arg0: T[K], ...args: any[]) &#x3D;&gt; void) {
        this.eventEmitter.prependOnceListener(&#x60;${event}&#x60;, listener)
    }

    eventNames(): (string | symbol)[] {
        return this.eventEmitter.eventNames()
    }
}</code></pre>
    </div>
</div>



                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'TypedEventEmitter.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
